//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of cresce.api;

class AppointmentsApi {
  AppointmentsApi([ApiClient? apiClient])
      : apiClient = apiClient ?? defaultApiClient;

  final ApiClient apiClient;

  /// Performs an HTTP 'POST /api/v1/Appointments/{id}/Cancelled' operation and returns the [Response].
  /// Parameters:
  ///
  /// * [int] id (required):
  ///
  /// * [CancelledModel] model (required):
  ///
  /// * [Object] authorization:
  Future<Response> _cancelledWithHttpInfo(
    int id,
    CancelledModel model, {
    required Object authorization,
  }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/v1/Appointments/{id}/Cancelled'
        .replaceAll('{id}', id.toString());

    // ignore: prefer_final_locals
    Object postBody = model;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    headerParams[r'authorization'] = parameterToString(authorization);

    const authNames = <String>[];
    const contentTypes = <String>[
      'application/json',
      'text/json',
      'application/_*+json'
    ];

    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Parameters:
  ///
  /// * [int] id (required):
  ///
  /// * [CancelledModel] model (required):
  ///
  /// * [Object] authorization:
  Future<AppointmentModel> cancelled(
    int id,
    CancelledModel model, {
    required Object authorization,
  }) async {
    final response = await _cancelledWithHttpInfo(
      id,
      model,
      authorization: authorization,
    );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }

    return await apiClient.deserializeAsync(
      await _decodeBodyBytes(response),
      'AppointmentModel',
    ) as AppointmentModel;
  }

  /// Performs an HTTP 'POST /api/v1/Appointments/{id}/Provided' operation and returns the [Response].
  /// Parameters:
  ///
  /// * [int] id (required):
  ///
  /// * [ProvidedModel] model (required):
  ///
  /// * [Object] authorization:
  Future<Response> providedWithHttpInfo(
    int id,
    ProvidedModel model, {
    required Object authorization,
  }) async {
    // ignore: prefer_const_declarations
    final path =
        r'/api/v1/Appointments/{id}/Provided'.replaceAll('{id}', id.toString());

    // ignore: prefer_final_locals
    Object postBody = model;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    headerParams[r'authorization'] = parameterToString(authorization);

    const authNames = <String>[];
    const contentTypes = <String>[
      'application/json',
      'text/json',
      'application/_*+json'
    ];

    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Parameters:
  ///
  /// * [int] id (required):
  ///
  /// * [ProvidedModel] model (required):
  ///
  /// * [Object] authorization:
  Future<AppointmentModel> provided(
    int id,
    ProvidedModel model, {
    required Object authorization,
  }) async {
    final response = await providedWithHttpInfo(
      id,
      model,
      authorization: authorization,
    );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    return await apiClient.deserializeAsync(
      await _decodeBodyBytes(response),
      'AppointmentModel',
    ) as AppointmentModel;
  }

  /// Performs an HTTP 'POST /api/v1/Appointments' operation and returns the [Response].
  /// Parameters:
  ///
  /// * [NewAppointmentModel] newAppointment (required):
  ///
  /// * [Object] authorization:
  Future<Response> _createAppointmentWithHttpInfo(
    NewAppointmentModel newAppointment, {
    Object? authorization,
  }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/v1/Appointments';

    // ignore: prefer_final_locals
    Object postBody = newAppointment;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (authorization != null) {
      headerParams[r'authorization'] = parameterToString(authorization);
    }

    const authNames = <String>[];
    const contentTypes = <String>[
      'application/json',
      'text/json',
      'application/_*+json'
    ];

    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Parameters:
  ///
  /// * [NewAppointmentModel] newAppointment (required):
  ///
  /// * [Object] authorization:
  Future<AppointmentModel?> createAppointment(
    NewAppointmentModel newAppointment, {
    Object? authorization,
  }) async {
    final response = await _createAppointmentWithHttpInfo(
      newAppointment,
      authorization: authorization,
    );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(
        await _decodeBodyBytes(response),
        'AppointmentModel',
      ) as AppointmentModel?;
    }
    return null;
  }

  /// Performs an HTTP 'GET /api/v1/Appointments' operation and returns the [Response].
  /// Parameters:
  ///
  /// * [Object] authorization:
  Future<Response> _getAppointmentsWithHttpInfo({
    Object? authorization,
  }) async {
    // Verify required params are set.

    // ignore: prefer_const_declarations
    final path = r'/api/v1/Appointments';

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (authorization != null) {
      headerParams[r'authorization'] = parameterToString(authorization);
    }

    const authNames = <String>[];
    const contentTypes = <String>[];

    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Parameters:
  ///
  /// * [Object] authorization:
  Future<List<AppointmentModel>> getAppointments({
    Object? authorization,
  }) async {
    final response = await _getAppointmentsWithHttpInfo(
      authorization: authorization,
    );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.statusCode != HttpStatus.noContent) {
      final responseBody = await _decodeBodyBytes(response);
      return (await apiClient.deserializeAsync(
              responseBody, 'List<AppointmentModel>') as List)
          .cast<AppointmentModel>()
          .toList(growable: false);
    }
    return <AppointmentModel>[];
  }

  /// Performs an HTTP 'GET /api/v1/Appointments/{from}/{to}' operation and returns the [Response].
  /// Parameters:
  ///
  /// * [DateTime] from (required):
  ///
  /// * [DateTime] to (required):
  ///
  /// * [Object] authorization:
  Future<Response> getAppointmentsBetweenDatesWithHttpInfo(
    DateTime from,
    DateTime to, {
    Object? authorization,
  }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/v1/Appointments/{from}/{to}'
        .replaceAll('{from}', from.toString())
        .replaceAll('{to}', to.toString());

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    headerParams[r'authorization'] = parameterToString(authorization);

    const authNames = <String>[];
    const contentTypes = <String>[];

    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      null,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Parameters:
  ///
  /// * [DateTime] from (required):
  ///
  /// * [DateTime] to (required):
  ///
  /// * [Object] authorization:
  Future<List<AppointmentModel>> getAppointmentsBetweenDates(
    DateTime from,
    DateTime to, {
    Object? authorization,
  }) async {
    final response = await getAppointmentsBetweenDatesWithHttpInfo(
      from,
      to,
      authorization: authorization,
    );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }

    final responseBody = await _decodeBodyBytes(response);
    return (await apiClient.deserializeAsync(
            responseBody, 'List<AppointmentModel>') as List)
        .cast<AppointmentModel>()
        .toList(growable: false);
  }
}
