//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of cresce.api;

class EmployeesApi {
  EmployeesApi([ApiClient? apiClient])
      : apiClient = apiClient ?? defaultApiClient;

  final ApiClient apiClient;

  /// Performs an HTTP 'POST /api/v1/Employees' operation and returns the [Response].
  /// Parameters:
  ///
  /// * [NewEmployeeModel] employeeModel (required):
  ///
  /// * [Object] user:
  Future<Response> _createEmployeeWithHttpInfo(
    NewEmployeeModel employeeModel, {
    Object? user,
  }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/v1/Employees';

    // ignore: prefer_final_locals
    Object postBody = employeeModel;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (user != null) {
      headerParams[r'user'] = parameterToString(user);
    }

    const authNames = <String>[];
    const contentTypes = <String>[
      'application/json',
      'text/json',
      'application/_*+json'
    ];

    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Parameters:
  ///
  /// * [NewEmployeeModel] employeeModel (required):
  ///
  /// * [Object] user:
  Future<EmployeeModel?> createEmployee(
    NewEmployeeModel employeeModel, {
    Object? user,
  }) async {
    final response = await _createEmployeeWithHttpInfo(
      employeeModel,
      user: user,
    );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(
        await _decodeBodyBytes(response),
        'EmployeeModel',
      ) as EmployeeModel?;
    }
    return null;
  }

  /// Performs an HTTP 'GET /api/v1/organization/{organization}/Employees' operation and returns the [Response].
  /// Parameters:
  ///
  /// * [String] organization (required):
  ///
  /// * [Object] user:
  Future<Response> _getEmployeesWithHttpInfo(
    String organization, {
    Object? user,
  }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/v1/organization/{organization}/Employees'
        .replaceAll('{organization}', organization);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (user != null) {
      headerParams[r'authorization'] = parameterToString(user);
    }

    const authNames = <String>[];
    const contentTypes = <String>[];

    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Parameters:
  ///
  /// * [String] organization (required):
  ///
  /// * [Object] user:
  Future<List<EmployeeModel>> getEmployees(
    String organization, {
    Object? user,
  }) async {
    final response = await _getEmployeesWithHttpInfo(
      organization,
      user: user,
    );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.statusCode != HttpStatus.noContent) {
      final responseBody = await _decodeBodyBytes(response);
      return (await apiClient.deserializeAsync(
              responseBody, 'List<EmployeeModel>') as List)
          .cast<EmployeeModel>()
          .toList(growable: false);
    }
    return <EmployeeModel>[];
  }

  /// Performs an HTTP 'GET /api/v1/Employees/{employeeId}/services' operation and returns the [Response].
  /// Parameters:
  ///
  /// * [int] employeeId (required):
  ///
  /// * [Object] authorization:
  Future<Response> _getServicesWithHttpInfo(
    int employeeId, {
    Object? authorization,
  }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/v1/Employees/{employeeId}/services'
        .replaceAll('{employeeId}', employeeId.toString());

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (authorization != null) {
      headerParams[r'authorization'] = parameterToString(authorization);
    }

    const authNames = <String>[];
    const contentTypes = <String>[];

    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Parameters:
  ///
  /// * [int] employeeId (required):
  ///
  /// * [Object] authorization:
  Future<EmployeeServicesModel?> getServices(
    int employeeId, {
    Object? authorization,
  }) async {
    final response = await _getServicesWithHttpInfo(
      employeeId,
      authorization: authorization,
    );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(
        await _decodeBodyBytes(response),
        'EmployeeServicesModel',
      ) as EmployeeServicesModel?;
    }
    return null;
  }

  /// Performs an HTTP 'POST /api/v1/Employees/validate' operation and returns the [Response].
  /// Parameters:
  ///
  /// * [EmployeePin] pin (required):
  ///
  /// * [Object] user:
  Future<Response> _validatePinWithHttpInfo(
    EmployeePin pin, {
    Object? user,
  }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/v1/Employees/validate';

    // ignore: prefer_final_locals
    Object postBody = pin;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (user != null) {
      headerParams[r'authorization'] = parameterToString(user);
    }

    const authNames = <String>[];
    const contentTypes = <String>[
      'application/json',
      'text/json',
      'application/_*+json'
    ];

    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Parameters:
  ///
  /// * [EmployeePin] pin (required):
  ///
  /// * [Object] user:
  Future<Authentication> validatePin(
    EmployeePin pin, {
    Object? user,
  }) async {
    final response = await _validatePinWithHttpInfo(
      pin,
      user: user,
    );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.statusCode != HttpStatus.noContent) {
      var result = await apiClient.deserializeAsync(
        await _decodeBodyBytes(response),
        'EmployeeLoginResultDto',
      ) as EmployeeLoginResultDto;

      return HttpBearerAuth()..accessToken = result.token;
    }
    return HttpBearerAuth();
  }
}
