//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of cresce.api;

class InvoicesApi {
  InvoicesApi([ApiClient? apiClient])
      : apiClient = apiClient ?? defaultApiClient;

  final ApiClient apiClient;

  /// Performs an HTTP 'GET /api/v1/Invoices/{year}/{month}' operation and returns the [Response].
  /// Parameters:
  ///
  /// * [int] year (required):
  ///
  /// * [int] month (required):
  ///
  /// * [Object] authorization:
  Future<Response> _getInvoiceSummaryWithHttpInfo(
    int year,
    int month, {
    Object? authorization,
  }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/v1/Invoices/{year}/{month}'
        .replaceAll('{year}', year.toString())
        .replaceAll('{month}', month.toString());

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (authorization != null) {
      headerParams[r'authorization'] = parameterToString(authorization);
    }

    const authNames = <String>[];
    const contentTypes = <String>[];

    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Parameters:
  ///
  /// * [int] year (required):
  ///
  /// * [int] month (required):
  ///
  /// * [Object] authorization:
  Future<List<InvoiceSummaryModel>> getInvoiceSummary(
    int year,
    int month, {
    Object? authorization,
  }) async {
    final response = await _getInvoiceSummaryWithHttpInfo(
      year,
      month,
      authorization: authorization,
    );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.statusCode != HttpStatus.noContent) {
      final responseBody = await _decodeBodyBytes(response);
      return (await apiClient.deserializeAsync(
              responseBody, 'List<InvoiceSummaryModel>') as List)
          .cast<InvoiceSummaryModel>()
          .toList(growable: false);
    }
    return <InvoiceSummaryModel>[];
  }

  /// Performs an HTTP 'POST /api/v1/Invoices' operation and returns the [Response].
  /// Parameters:
  ///
  /// * [InvoiceAppointmentsModel] request (required):
  ///
  /// * [Object] authorization:
  Future<Response> _invoiceAppointmentsWithHttpInfo(
    InvoiceAppointmentsModel request, {
    Object? authorization,
  }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/v1/Invoices';

    // ignore: prefer_final_locals
    Object postBody = request;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (authorization != null) {
      headerParams[r'authorization'] = parameterToString(authorization);
    }

    const authNames = <String>[];
    const contentTypes = <String>[
      'application/json',
      'text/json',
      'application/_*+json'
    ];

    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Parameters:
  ///
  /// * [InvoiceAppointmentsModel] request (required):
  ///
  /// * [Object] authorization:
  Future<InvoiceModel?> invoiceAppointments(
    InvoiceAppointmentsModel request, {
    Object? authorization,
  }) async {
    final response = await _invoiceAppointmentsWithHttpInfo(
      request,
      authorization: authorization,
    );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(
        await _decodeBodyBytes(response),
        'InvoiceModel',
      ) as InvoiceModel?;
    }
    return null;
  }
}
