//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of cresce.api;

class ServicesApi {
  ServicesApi([ApiClient? apiClient])
      : apiClient = apiClient ?? defaultApiClient;

  final ApiClient apiClient;

  /// Performs an HTTP 'POST /api/v1/Services' operation and returns the [Response].
  /// Parameters:
  ///
  /// * [NewServiceModel] newService (required):
  ///
  /// * [Object] authorization:
  Future<Response> _createServiceWithHttpInfo(
    NewServiceModel newService, {
    Object? authorization,
  }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/v1/Services';

    // ignore: prefer_final_locals
    Object postBody = newService;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (authorization != null) {
      headerParams[r'authorization'] = parameterToString(authorization);
    }

    const authNames = <String>[];
    const contentTypes = <String>[
      'application/json',
      'text/json',
      'application/_*+json'
    ];

    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Parameters:
  ///
  /// * [NewServiceModel] newService (required):
  ///
  /// * [Object] authorization:
  Future<ServiceModel?> createService(
    NewServiceModel newService, {
    Object? authorization,
  }) async {
    final response = await _createServiceWithHttpInfo(
      newService,
      authorization: authorization,
    );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(
        await _decodeBodyBytes(response),
        'ServiceModel',
      ) as ServiceModel?;
    }
    return null;
  }

  /// Performs an HTTP 'GET /api/v1/Services' operation and returns the [Response].
  /// Parameters:
  ///
  /// * [Object] authorization:
  Future<Response> _getServicesWithHttpInfo({
    Object? authorization,
  }) async {
    // Verify required params are set.

    // ignore: prefer_const_declarations
    final path = r'/api/v1/Services';

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (authorization != null) {
      headerParams[r'authorization'] = parameterToString(authorization);
    }

    const authNames = <String>[];
    const contentTypes = <String>[];

    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Parameters:
  ///
  /// * [Object] authorization:
  Future<List<ServiceModel>> getServices({
    Object? authorization,
  }) async {
    final response = await _getServicesWithHttpInfo(
      authorization: authorization,
    );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.statusCode != HttpStatus.noContent) {
      final responseBody = await _decodeBodyBytes(response);
      return (await apiClient.deserializeAsync(
              responseBody, 'List<ServiceModel>') as List)
          .cast<ServiceModel>()
          .toList(growable: false);
    }
    return <ServiceModel>[];
  }

  /// Performs an HTTP 'GET /api/v1/Services/{serviceId}' operation and returns the [Response].
  /// Parameters:
  ///
  /// * [int] serviceId (required):
  ///
  /// * [Object] authorization:
  Future<Response> _getServiceWithHttpInfo(
    int serviceId, {
    Object? authorization,
  }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/v1/Services/{serviceId}'
        .replaceAll('{serviceId}', serviceId.toString());

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (authorization != null) {
      headerParams[r'authorization'] = parameterToString(authorization);
    }

    const authNames = <String>[];
    const contentTypes = <String>[];

    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Parameters:
  ///
  /// * [int] serviceId (required):
  ///
  /// * [Object] authorization:
  Future<ServiceModel> getService(
    int serviceId, {
    Object? authorization,
  }) async {
    final response = await _getServiceWithHttpInfo(
      serviceId,
      authorization: authorization,
    );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }

    return await apiClient.deserializeAsync(
      await _decodeBodyBytes(response),
      'ServiceModel',
    ) as ServiceModel;
  }

  /// Performs an HTTP 'PUT /api/v1/Services' operation and returns the [Response].
  /// Parameters:
  ///
  /// * [UpdatedServiceModel] newService (required):
  ///
  /// * [Object] authorization:
  Future<Response> _updateServiceWithHttpInfo(
    UpdatedServiceModel newService, {
    Object? authorization,
  }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/v1/Services';

    // ignore: prefer_final_locals
    Object postBody = newService;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (authorization != null) {
      headerParams[r'authorization'] = parameterToString(authorization);
    }

    const authNames = <String>[];
    const contentTypes = <String>[
      'application/json',
      'text/json',
      'application/_*+json'
    ];

    return apiClient.invokeAPI(
      path,
      'PUT',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Parameters:
  ///
  /// * [UpdatedServiceModel] newService (required):
  ///
  /// * [Object] authorization:
  Future<ServiceModel?> updateService(
    UpdatedServiceModel newService, {
    Object? authorization,
  }) async {
    final response = await _updateServiceWithHttpInfo(
      newService,
      authorization: authorization,
    );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(
        await _decodeBodyBytes(response),
        'ServiceModel',
      ) as ServiceModel?;
    }
    return null;
  }
}
