// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of cresce.api;

class CancelledModel {
  /// Returns a new [CancelledModel] instance.
  CancelledModel({
    required this.date,
    required this.reason,
  });

  final DateTime date;

  final String reason;

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      other is CancelledModel && other.date == date && other.reason == reason;

  @override
  int get hashCode => date.hashCode + reason.hashCode;

  @override
  String toString() => 'CancelledModel[date=$date, reason=$reason]';

  Map<String, dynamic> toJson() {
    final json = <String, dynamic>{};
    json[r'date'] = date.toUtc().toIso8601String();
    json[r'reason'] = reason;
    return json;
  }

  /// Returns a new [CancelledModel] instance and imports its values from
  /// [value] if it's a [Map], null otherwise.
  // ignore: prefer_constructors_over_static_methods
  static CancelledModel fromJson(dynamic value) {
    final json = value.cast<String, dynamic>();
    return CancelledModel(
      date: mapDateTime(json, r'date', '')!,
      reason: mapValueOfType<String>(json, r'reason')!,
    );
  }

  static Map<String, CancelledModel> mapFromJson(dynamic json) {
    final map = <String, CancelledModel>{};
    if (json is Map && json.isNotEmpty) {
      json.cast<String, dynamic>().forEach(
          (key, dynamic value) => map[key] = CancelledModel.fromJson(value));
    }
    return map;
  }
}
