import 'package:cresce_api/api.dart';
import 'package:test/test.dart';

void main() {
  group(AuthenticationApi, () {
    test('login valid credentials returns token', () async {
      var api = AuthenticationApi();
      var credentials = CredentialsDto(user: 'myUser', password: 'myPass');

      var result = await api.login(credentials);

      expect(result, isNotNull);
      expect(result.accessToken, isNotNull);
    });

    test('login invalid credentials throws ApiClientException', () async {
      var api = AuthenticationApi();
      var credentials = CredentialsDto(user: 'myUser', password: 'myPas1');

      expect(
        () async => await api.login(credentials),
        throwsA(TypeMatcher<ApiException>()),
      );
    });
  });
}
